diff --git a/app/test-bbdev/meson.build b/app/test-bbdev/meson.build
index d3f2b7701..4f53a2ed8 100644
--- a/app/test-bbdev/meson.build
+++ b/app/test-bbdev/meson.build
@@ -7,6 +7,6 @@ sources = files('main.c',
 		'test_bbdev_vector.c')
 allow_experimental_apis = true
 deps += ['bbdev', 'bus_vdev']
-if dpdk_conf.has('RTE_LIBRTE_PMD_FPGA_LTE_FEC')
-	deps += ['bbdev_fpga_lte_fec']
-endif
\ No newline at end of file
+if dpdk_conf.has('RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC')
+	deps += ['pmd_bbdev_fpga_lte_fec']
+endif
diff --git a/app/test-bbdev/test_bbdev_perf.c b/app/test-bbdev/test_bbdev_perf.c
index 7ab61eff8..fb9045fc5 100644
--- a/app/test-bbdev/test_bbdev_perf.c
+++ b/app/test-bbdev/test_bbdev_perf.c
@@ -18,7 +18,7 @@
 #include <rte_hexdump.h>
 #include <rte_interrupts.h>
 
-#ifdef RTE_LIBRTE_PMD_FPGA_LTE_FEC
+#ifdef RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC
 #include <fpga_lte_fec.h>
 #endif
 
@@ -30,7 +30,7 @@
 #define MAX_QUEUES RTE_MAX_LCORE
 #define TEST_REPETITIONS 1000
 
-#ifdef RTE_LIBRTE_PMD_FPGA_LTE_FEC
+#ifdef RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC
 #define FPGA_PF_DRIVER_NAME ("intel_fpga_lte_fec_pf")
 #define FPGA_VF_DRIVER_NAME ("intel_fpga_lte_fec_vf")
 #define VF_UL_QUEUE_VALUE 4
@@ -520,7 +520,7 @@ add_bbdev_dev(uint8_t dev_id, struct rte_bbdev_info *info,
  * if '-i' flag is set and using fpga device
  */
 #ifndef RTE_BUILD_SHARED_LIB
-#ifdef RTE_LIBRTE_PMD_FPGA_LTE_FEC
+#ifdef RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC
 	if ((get_init_device() == true) &&
 		(!strcmp(info->drv.driver_name, FPGA_PF_DRIVER_NAME))) {
 		struct fpga_lte_fec_conf conf;
diff --git a/config/common_base b/config/common_base
index 8ef75c203..c102699dd 100644
--- a/config/common_base
+++ b/config/common_base
@@ -556,7 +556,7 @@ CONFIG_RTE_LIBRTE_PMD_BBDEV_TURBO_SW=y
 #
 # Compile PMD for Intel FPGA LTE FEC bbdev device
 #
-CONFIG_RTE_LIBRTE_PMD_FPGA_LTE_FEC=y
+CONFIG_RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC=y
 
 #
 # Compile generic crypto device library
diff --git a/doc/guides/bbdevs/fpga_lte_fec.rst b/doc/guides/bbdevs/fpga_lte_fec.rst
index 4a3061a90..206b6f4f9 100644
--- a/doc/guides/bbdevs/fpga_lte_fec.rst
+++ b/doc/guides/bbdevs/fpga_lte_fec.rst
@@ -52,7 +52,7 @@ Installation
 
 Section 3 of the DPDK manual provides instuctions on installing and compiling DPDK. The
 default set of bbdev compile flags may be found in config/common_base, where for example
-the flag to build the FPGA LTE FEC device, ``CONFIG_RTE_LIBRTE_PMD_FPGA_LTE_FEC``, is already
+the flag to build the FPGA LTE FEC device, ``CONFIG_RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC``, is already
 set. It is assumed DPDK has been compiled using for instance:
 
 .. code-block:: console
diff --git a/drivers/baseband/Makefile b/drivers/baseband/Makefile
index ceffc7d49..91048beca 100644
--- a/drivers/baseband/Makefile
+++ b/drivers/baseband/Makefile
@@ -10,7 +10,7 @@ DIRS-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_NULL) += null
 DEPDIRS-null = $(core-libs)
 DIRS-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_TURBO_SW) += turbo_sw
 DEPDIRS-turbo_sw = $(core-libs)
-DIRS-$(CONFIG_RTE_LIBRTE_PMD_FPGA_LTE_FEC) += fpga_lte_fec
+DIRS-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC) += fpga_lte_fec
 DEPDIRS-fpga_lte_fec = $(core-libs)
 
 include $(RTE_SDK)/mk/rte.subdir.mk
diff --git a/drivers/baseband/fpga_lte_fec/Makefile b/drivers/baseband/fpga_lte_fec/Makefile
index a38a396ae..2369bd27f 100644
--- a/drivers/baseband/fpga_lte_fec/Makefile
+++ b/drivers/baseband/fpga_lte_fec/Makefile
@@ -4,7 +4,7 @@
 include $(RTE_SDK)/mk/rte.vars.mk
 
 # library name
-LIB = librte_pmd_fpga_lte_fec.a
+LIB = librte_pmd_bbdev_fpga_lte_fec.a
 
 # build flags
 CFLAGS += -DALLOW_EXPERIMENTAL_API
@@ -21,9 +21,9 @@ EXPORT_MAP := rte_pmd_bbdev_fpga_lte_fec_version.map
 LIBABIVER := 1
 
 # library source files
-SRCS-$(CONFIG_RTE_LIBRTE_PMD_FPGA_LTE_FEC) += fpga_lte_fec.c
+SRCS-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC) += fpga_lte_fec.c
 
 # export include files
-SYMLINK-$(CONFIG_RTE_LIBRTE_PMD_FPGA_LTE_FEC)-include += fpga_lte_fec.h
+SYMLINK-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC)-include += fpga_lte_fec.h
 
 include $(RTE_SDK)/mk/rte.lib.mk
diff --git a/mk/rte.app.mk b/mk/rte.app.mk
index ba5c39e01..1806abaf7 100644
--- a/mk/rte.app.mk
+++ b/mk/rte.app.mk
@@ -226,7 +226,7 @@ _LDLIBS-$(CONFIG_RTE_LIBRTE_NETVSC_PMD)     += -lrte_pmd_netvsc
 
 ifeq ($(CONFIG_RTE_LIBRTE_BBDEV),y)
 _LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_NULL)     += -lrte_pmd_bbdev_null
-_LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_FPGA_LTE_FEC) += -lrte_pmd_fpga_lte_fec
+_LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_FPGA_LTE_FEC) += -lrte_pmd_bbdev_fpga_lte_fec
 
 # TURBO SOFTWARE PMD is dependent on the FLEXRAN library
 _LDLIBS-$(CONFIG_RTE_LIBRTE_PMD_BBDEV_TURBO_SW) += -lrte_pmd_bbdev_turbo_sw