diff --git a/app/test/test_cmdline_portlist.c b/app/test/test_cmdline_portlist.c
index 0dc6d0030..de9ada7e7 100644
--- a/app/test/test_cmdline_portlist.c
+++ b/app/test/test_cmdline_portlist.c
@@ -117,7 +117,7 @@ test_parse_portlist_invalid_param(void)
 	}

 	/* try null buf */
-	ret = cmdline_parse_portlist(NULL, NULL, (void*)&result,
+	ret = cmdline_parse_portlist(NULL, NULL, (void *)&result,
 		sizeof(result));
 	if (ret != -1) {
 		printf("Error: parser accepted null string!\n");
diff --git a/examples/vmdq_dcb/main.c b/examples/vmdq_dcb/main.c
index 594c4f195..14590ef70 100644
--- a/examples/vmdq_dcb/main.c
+++ b/examples/vmdq_dcb/main.c
@@ -705,7 +705,7 @@ main(int argc, char *argv[])
 	/* call lcore_main() on every slave lcore */
 	i = 0;
 	RTE_LCORE_FOREACH_SLAVE(lcore_id) {
-		rte_eal_remote_launch(lcore_main, (void*)i++, lcore_id);
+		rte_eal_remote_launch(lcore_main, (void *)i++, lcore_id);
 	}
 	/* call on master too */
 	(void) lcore_main((void*)i);
diff --git a/lib/librte_cryptodev/rte_cryptodev.c b/lib/librte_cryptodev/rte_cryptodev.c
index 0f72d5892..9a054daa6 100644
--- a/lib/librte_cryptodev/rte_cryptodev.c
+++ b/lib/librte_cryptodev/rte_cryptodev.c
@@ -803,7 +803,7 @@ rte_cryptodev_queue_pairs_config(struct rte_cryptodev *dev, uint16_t nb_qpairs,

 	if ((dev == NULL) || (nb_qpairs < 1)) {
 		CDEV_LOG_ERR("invalid param: dev %p, nb_queues %u",
-							(void*)dev, nb_qpairs);
+							(void *)dev, nb_qpairs);
 		return -EINVAL;
 	}

diff --git a/lib/librte_eal/common/eal_common_tailqs.c b/lib/librte_eal/common/eal_common_tailqs.c
index 7d7faf316..88c6428cb 100644
--- a/lib/librte_eal/common/eal_common_tailqs.c
+++ b/lib/librte_eal/common/eal_common_tailqs.c
@@ -65,7 +65,7 @@ rte_dump_tailq(FILE *f)
 		const struct rte_tailq_entry_head *head = &tailq->tailq_head;

 		fprintf(f, "Tailq %u: qname:<%s>, tqh_first:%p, tqh_last:%p\n",
-			i, tailq->name, (void*)head->tqh_first, (void*)head->tqh_last);
+			i, tailq->name, (void *)head->tqh_first, (void *)head->tqh_last);
 	}
 	rte_mcfg_tailq_read_unlock();
 }
diff --git a/lib/librte_eal/common/include/rte_bitmap.h b/lib/librte_eal/common/include/rte_bitmap.h
index 2c7f74538..7d063620b 100644
--- a/lib/librte_eal/common/include/rte_bitmap.h
+++ b/lib/librte_eal/common/include/rte_bitmap.h
@@ -95,8 +95,8 @@ __rte_bitmap_index2_set(struct rte_bitmap *bmp)

 static inline uint32_t
 __rte_bitmap_get_memory_footprint(const uint32_t n_bits,
-	uint32_t * __restrict array1_byte_offset, uint32_t * __restrict array1_slabs,
-	uint32_t * __restrict array2_byte_offset, uint32_t * __restrict array2_slabs)
+	uint32_t *__restrict array1_byte_offset, uint32_t *__restrict array1_slabs,
+	uint32_t *__restrict array2_byte_offset, uint32_t *__restrict array2_slabs)
 {
 	uint32_t n_slabs_context, n_slabs_array1, n_cache_lines_context_and_array1;
 	uint32_t n_cache_lines_array2;
diff --git a/lib/librte_eal/common/include/rte_hexdump.h b/lib/librte_eal/common/include/rte_hexdump.h
index d85b33ae2..68f6f689f 100644
--- a/lib/librte_eal/common/include/rte_hexdump.h
+++ b/lib/librte_eal/common/include/rte_hexdump.h
@@ -50,7 +50,7 @@ rte_hexdump(FILE *f, const char * title, const void * buf, unsigned int len);
 */

 void
-rte_memdump(FILE *f, const char * title, const void * buf, const unsigned int len);
+rte_memdump(FILE *f, const char *title, const void *buf, const unsigned int len);


 #ifdef __cplusplus
diff --git a/lib/librte_eal/common/malloc_elem.c b/lib/librte_eal/common/malloc_elem.c
index 193d7526b..acc0c0505 100644
--- a/lib/librte_eal/common/malloc_elem.c
+++ b/lib/librte_eal/common/malloc_elem.c
@@ -666,8 +666,8 @@ elem_state_to_str(enum elem_state state)
 void
 malloc_elem_dump(const struct malloc_elem *elem, FILE *f)
 {
-	fprintf(f, "Malloc element at %p (%s)\n", (const void*)elem,
+	fprintf(f, "Malloc element at %p (%s)\n", (const void *)elem,
 			elem_state_to_str(elem->state));
 	fprintf(f, "  len: 0x%zx pad: 0x%" PRIx32 "\n", elem->size, elem->pad);
-	fprintf(f, "  prev: %p next: %p\n", (void*)elem->prev, (void*)elem->next);
+	fprintf(f, "  prev: %p next: %p\n", (void *)elem->prev, (void *)elem->next);
 }
diff --git a/lib/librte_mbuf/rte_mbuf.c b/lib/librte_mbuf/rte_mbuf.c
index de46fa7a2..f3fe16eb0 100644
--- a/lib/librte_mbuf/rte_mbuf.c
+++ b/lib/librte_mbuf/rte_mbuf.c
@@ -474,7 +474,7 @@ rte_pktmbuf_dump(FILE *f, const struct rte_mbuf *m, unsigned dump_len)
 	__rte_mbuf_sanity_check(m, 1);

 	fprintf(f, "dump mbuf at %p, iova=%"PRIx64", buf_len=%u\n",
-	       (const void*)m, (uint64_t)m->buf_iova, (unsigned)m->buf_len);
+	       (const void *)m, (uint64_t)m->buf_iova, (unsigned)m->buf_len);
 	fprintf(f, "  pkt_len=%"PRIu32", ol_flags=%"PRIx64", nb_segs=%u, "
 	       "in_port=%u\n", m->pkt_len, m->ol_flags,
 	       (unsigned)m->nb_segs, (unsigned)m->port);
@@ -484,7 +484,8 @@ rte_pktmbuf_dump(FILE *f, const struct rte_mbuf *m, unsigned dump_len)
 		__rte_mbuf_sanity_check(m, 0);

 		fprintf(f, "  segment at %p, data=%p, data_len=%u\n",
-			(const void*)m, (void*)rte_pktmbuf_mtod(m, void *), (unsigned)m->data_len);
+			(const void *)m, (void *)rte_pktmbuf_mtod(m, void *),
+			(unsigned int)m->data_len);
 		len = dump_len;
 		if (len > m->data_len)
 			len = m->data_len;
diff --git a/lib/librte_mempool/rte_mempool.c b/lib/librte_mempool/rte_mempool.c
index b172a058e..873712769 100644
--- a/lib/librte_mempool/rte_mempool.c
+++ b/lib/librte_mempool/rte_mempool.c
@@ -1200,7 +1200,7 @@ rte_mempool_dump(FILE *f, struct rte_mempool *mp)
 	RTE_ASSERT(f != NULL);
 	RTE_ASSERT(mp != NULL);

-	fprintf(f, "mempool <%s>@%p\n", mp->name, (void*)mp);
+	fprintf(f, "mempool <%s>@%p\n", mp->name, (void *)mp);
 	fprintf(f, "  flags=%x\n", mp->flags);
 	fprintf(f, "  pool=%p\n", mp->pool_data);
 	fprintf(f, "  iova=0x%" PRIx64 "\n", mp->mz->iova);
diff --git a/lib/librte_ring/rte_ring.c b/lib/librte_ring/rte_ring.c
index 86d0c8232..43d64e34b 100644
--- a/lib/librte_ring/rte_ring.c
+++ b/lib/librte_ring/rte_ring.c
@@ -232,7 +232,7 @@ rte_ring_free(struct rte_ring *r)
 void
 rte_ring_dump(FILE *f, const struct rte_ring *r)
 {
-	fprintf(f, "ring <%s>@%p\n", r->name, (const void*)r);
+	fprintf(f, "ring <%s>@%p\n", r->name, (const void *)r);
 	fprintf(f, "  flags=%x\n", r->flags);
 	fprintf(f, "  size=%"PRIu32"\n", r->size);
 	fprintf(f, "  capacity=%"PRIu32"\n", r->capacity);